import{deleteAsync}from"del";
import gulp from"gulp";

import{SOURCES_GLOB,BUILD,TYPESCRIPT_TESTS}from"../../files.js";
import{getWatchTask}from"../../watch.js";

import{babel}from"./babel.js";
import{copy}from"./copy.js";
import{buildTypes}from"./types.js";




const clean=()=>deleteAsync(`${BUILD}/**`,{onlyFiles:true});

const rebuild=gulp.parallel(copy,babel,buildTypes);
export const build=gulp.series(clean,rebuild);


build.description="Build source files";

const buildWatchTask=getWatchTask(
[SOURCES_GLOB,`!${TYPESCRIPT_TESTS}`],
rebuild
);
export const buildWatch=gulp.series(build,buildWatchTask);


buildWatch.description="Build source files (watch mode)";